# Start from golang base image
FROM golang:alpine as builder

ENV GO111MODULE=on

# Install git.
# Git is required for fetching the dependencies.
RUN apk update && apk add --no-cache git

# Set the current working directory inside the container
WORKDIR /app

# Copy go mod and sum files
COPY go.mod go.sum ./

# Download all dependencies. Dependencies will be cached if the go.mod and the go.sum files are not changed
RUN go mod download

# Copy the source from the current directory to the working Directory inside the container
COPY . /app

# Build the Go app
#RUN go generate pckr2
RUN CGO_ENABLED=0 GOOS=linux go build -a -installsuffix cgo -o main .

# Start a new stage from scratch
FROM alpine:latest
RUN apk --no-cache add ca-certificates

WORKDIR /app
#RUN addgroup tellgroup && adduser telluser
RUN addgroup tellgroup
RUN adduser -D -G tellgroup telluser
RUN chmod -R 777 /app

# Copy the Pre-built binary file from the previous stage. Observe we also copied the .env file
COPY --from=builder /app/main .
#COPY --from=builder /app/.env .
COPY --from=builder /app/application.properties .

# Expose port 8080 to the outside world
EXPOSE 8080

USER telluser

#Command to run the executable
#RUN go generate pckr2
CMD ["./main"]
